const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const invoices = sequelize.define(
    'invoices',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

number: {
        type: DataTypes.TEXT,
      
      

      },

issue_date: {
        type: DataTypes.DATE,
      
      

      },

due_date: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"issued",


"overdue",


"paid",


"cancelled",


"refunded"

        ],

      },

subtotal: {
        type: DataTypes.DECIMAL,
      
      

      },

discount_total: {
        type: DataTypes.DECIMAL,
      
      

      },

tax_total: {
        type: DataTypes.DECIMAL,
      
      

      },

total: {
        type: DataTypes.DECIMAL,
      
      

      },

amount_paid: {
        type: DataTypes.DECIMAL,
      
      

      },

amount_due: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  invoices.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
















    db.invoices.hasMany(db.invoice_items, {
      as: 'invoice_items_invoice',
      foreignKey: {
          name: 'invoiceId',
      },
      constraints: false,
    });


    db.invoices.hasMany(db.payments, {
      as: 'payments_invoice',
      foreignKey: {
          name: 'invoiceId',
      },
      constraints: false,
    });







    db.invoices.hasMany(db.alerts, {
      as: 'alerts_invoice',
      foreignKey: {
          name: 'invoiceId',
      },
      constraints: false,
    });





//end loop



    db.invoices.belongsTo(db.clients, {
      as: 'client',
      foreignKey: {
        name: 'clientId',
      },
      constraints: false,
    });

    db.invoices.belongsTo(db.quotes, {
      as: 'quote',
      foreignKey: {
        name: 'quoteId',
      },
      constraints: false,
    });

    db.invoices.belongsTo(db.sales, {
      as: 'sale',
      foreignKey: {
        name: 'saleId',
      },
      constraints: false,
    });

    db.invoices.belongsTo(db.users, {
      as: 'created_by_user',
      foreignKey: {
        name: 'created_by_userId',
      },
      constraints: false,
    });



    db.invoices.hasMany(db.file, {
      as: 'pdf',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.invoices.getTableName(),
        belongsToColumn: 'pdf',
      },
    });


    db.invoices.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.invoices.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return invoices;
};


